require 'mysql'
require 'criteria/sql'

module Criteria
  class MysqlTable < SQLTable
    attr_reader :_db

    def initialize(db, table)
      super(table)
      @criterion_type = MysqlCriterion
      @_db            = db
    end #m:initialize

    class << self; alias :get :new; end
  end #c:MysqlTable

  class MysqlCriterion < SQLCriterion
    def select(*args)
      sql = super
      return @_parent._db.query(sql)
    end #m:select

    def _translate_fn(op)
      case op
      when :=~;   "RLIKE"
      when :"!~"; "NOT RLIKE"
      else super
      end
    end #m:_translate_fn

    def _translate_item(item)
      case item
      when String; super(@parent._db.quote(item))
      end
    end #m:_translate_item
  end #c:MysqlCriterion
end
